<?php
/**
 * Created by PhpStorm.
 * User: niko
 * Date: 29.01.15
 * Time: 10:14
 */

function commerce_payqr_config($form, &$form_state) {
  $form['merchant_data'] = array(
    '#type' => 'fieldset',
    '#title' => t('Merchant info'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );
  $form['merchant_data']['commerce_payqr_merchant_id'] = array(
    '#type' => 'textfield',
    '#title' => t('PayQR merchant ID'),
    '#default_value' => variable_get('commerce_payqr_merchant_id', ''),
    '#size' => 60,
    '#maxlength' => 128,
    '#required' => TRUE,
  );
  $form['merchant_data']['commerce_payqr_secret_key_in'] = array(
    '#type' => 'textfield',
    '#title' => t('PayQR secret key in'),
    '#default_value' => variable_get('commerce_payqr_secret_key_in', ''),
    '#size' => 60,
    '#maxlength' => 128,
    '#required' => TRUE,
  );
  $form['merchant_data']['commerce_payqr_secret_key_out'] = array(
    '#type' => 'textfield',
    '#title' => t('PayQR secret key out'),
    '#default_value' => variable_get('commerce_payqr_secret_key_out', ''),
    '#size' => 60,
    '#maxlength' => 128,
    '#required' => TRUE,
  );

  $form['button_style'] = array(
    '#type' => 'fieldset',
    '#title' => t('Button style'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );
  $form['button_style']['commerce_payqr_button_color'] = array(
    '#type' => 'select',
    '#title' => t('Button color'),
    '#options' => array(
      'payqr-button_green' => t('Green'),
      'payqr-button_blue' => t('Blue'),
      'payqr-button_orange' => t('Orange'),
      'payqr-button_red' => t('Red'),
    ),
    '#default_value' => variable_get('commerce_payqr_button_color', 'payqr-button_green'),
  );
  $form['button_style']['commerce_payqr_button_form'] = array(
    '#type' => 'select',
    '#title' => t('Button form'),
    '#options' => array(
      'payqr-button_sharp' => t('Sharp'),
      'payqr-button_rude' => t('Rude'),
      'payqr-button_soft' => t('Soft'),
      'payqr-button_sleek' => t('Sleek'),
      'payqr-button_oval' => t('Oval'),
    ),
    '#default_value' => variable_get('commerce_payqr_button_form', 'payqr-button_sharp'),
  );
  $form['button_style']['commerce_payqr_button_gradient'] = array(
    '#type' => 'select',
    '#title' => t('Button gradient'),
    '#options' => array(
      'payqr-button_flat' => t('Flat'),
      'payqr-button_gradient' => t('Gradient'),
    ),
    '#default_value' => variable_get('commerce_payqr_button_gradient', 'payqr-button_flat'),
  );
  $form['button_style']['commerce_payqr_button_text_case'] = array(
    '#type' => 'select',
    '#title' => t('Button text case'),
    '#options' => array(
      'payqr-button_lowercase' => t('Lower case'),
      'payqr-button_standardcase' => t('Standard case'),
      'payqr-button_uppercase' => t('Upper case'),
    ),
    '#default_value' => variable_get('commerce_payqr_button_text_case', 'payqr-button_standardcase'),
  );
  $form['button_style']['commerce_payqr_button_text_width'] = array(
    '#type' => 'select',
    '#title' => t('Button text font width'),
    '#options' => array(
      'payqr-button_font_bold' => t('Bold'),
      'payqr-button_font_normal' => t('Normal'),
    ),
    '#default_value' => variable_get('commerce_payqr_button_text_width', 'payqr-button_font_normal'),
  );
  $form['button_style']['commerce_payqr_button_text_size'] = array(
    '#type' => 'select',
    '#title' => t('Button text font width'),
    '#options' => array(
      'payqr-button_text_large' => t('Large'),
      'payqr-button_text_normal' => t('Normal'),
      'payqr-button_text_small' => t('Small'),
    ),
    '#default_value' => variable_get('commerce_payqr_button_text_size', 'payqr-button_text_normal'),
  );
  $form['button_style']['commerce_payqr_button_height'] = array(
    '#type' => 'textfield',
    '#title' => t('Button height'),
    '#description' => t('Set button height or <em>auto</em> for auto height'),
    '#default_value' => variable_get('commerce_payqr_button_height', 'auto'),
    '#size' => 60,
    '#maxlength' => 128,
  );
  $form['button_style']['commerce_payqr_button_width'] = array(
    '#type' => 'textfield',
    '#title' => t('Button width'),
    '#description' => t('Set button width or <em>auto</em> for auto width'),
    '#default_value' => variable_get('commerce_payqr_button_width', 'auto'),
    '#size' => 60,
    '#maxlength' => 128,
  );

  $data['data-firstname-required'] = variable_get('commerce_payqr_firstname_required', 'default');
  $data['data-lastname-required'] = variable_get('commerce_payqr_firstname_required', 'default');
  $data['data-phone-required'] = variable_get('commerce_payqr_phone_required', 'default');
  $data['data-email-required'] = variable_get('commerce_payqr_email_required', 'default');
  if (module_exists('commerce_shipping')) {
    $form['delivery'] = array(
      '#type' => 'fieldset',
      '#title' => t('Delivery'),
      '#collapsible' => TRUE,
      '#collapsed' => TRUE,
    );
    $form['delivery']['commerce_payqr_deliverycases_required'] = array(
      '#type' => 'select',
      '#title' => t('Deliverycases'),
      '#description' => t('Set Deliverycases to <em>default</em> for get setting from PayQR side'),
      '#options' => array(
        'default' => t('Default'),
        'deny' => t('Deny'),
        'required' => t('Required'),
      ),
      '#default_value' => variable_get('commerce_payqr_deliverycases_required', 'default'),
    );

    $form['delivery']['commerce_payqr_delivery_required'] = array(
      '#type' => 'select',
      '#title' => t('Delivery required'),
      '#description' => t('Set Delivery required to <em>default</em> for get setting from PayQR side'),
      '#options' => array(
        'default' => t('Default'),
        'deny' => t('Deny'),
        'required' => t('Required'),
        'notrequired' => t('Not required'),
      ),
      '#default_value' => variable_get('commerce_payqr_delivery_required', 'default'),
    );
    $form['delivery']['commerce_payqr_pickpoints_required'] = array(
      '#type' => 'select',
      '#title' => t('Pickup points'),
      '#description' => t('Set Pickup points to <em>default</em> for get setting from PayQR side'),
      '#options' => array(
        'default' => t('Default'),
        'deny' => t('Deny'),
        'required' => t('Required'),
      ),
      '#default_value' => variable_get('commerce_payqr_pickpoints_required', 'default'),
    );
    $form['delivery']['commerce_payqr_deliverycases_prefix'] = array(
      '#type' => 'textfield',
      '#title' => t('Deliverycases prefix'),
      '#description' => t('Mashine name prefix for shipping service that will be shown as deliverycases in app (without trailing _)'),
      '#default_value' => variable_get('commerce_payqr_deliverycases_prefix', 'payqr_dc'),
    );
    $form['delivery']['commerce_payqr_pickpoints_prefix'] = array(
      '#type' => 'textfield',
      '#title' => t('Pickpoints prefix'),
      '#description' => t('Mashine name prefix for shipping service that will be shown as pickpoints in app (without trailing _)'),
      '#default_value' => variable_get('commerce_payqr_pickpoints_prefix', 'payqr_pp'),
    );
  }

  if (module_exists('commerce_coupon')) {
    $form['promo'] = array(
      '#type' => 'fieldset',
      '#title' => t('Promo'),
      '#collapsible' => TRUE,
      '#collapsed' => TRUE,
    );
    $form['promo']['commerce_payqr_promo_required'] = array(
      '#type' => 'select',
      '#title' => t('Promo required'),
      '#description' => t('Set Promo required to <em>default</em> for get setting from PayQR side'),
      '#options' => array(
        'default' => t('Default'),
        'deny' => t('Deny'),
        'required' => t('R  equired'),
        'notrequired' => t('Not required'),
      ),
      '#default_value' => variable_get('commerce_payqr_promo_required', 'default'),
    );

    $form['promo']['commerce_payqr_promo_description'] = array(
      '#type' => 'textarea',
      '#title' => t('Promo description'),
      '#default_value' => variable_get('commerce_payqr_promo_description', ''),
    );
  }

  $data['data-commissionpercent'] = variable_get('commerce_payqr_commissionpercent', 0);
  $data['data-userdata'] = variable_get('commerce_payqr_userdata', '');


  $form['images'] = array(
    '#type' => 'fieldset',
    '#title' => t('Images settimgs'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );

  $types = commerce_product_types();
//  dpm($types,'$types');
//  $fields = field_info_fields();
  foreach ($types as $name => $type) {
    $options = array();
    $instances = field_info_instances('commerce_product', $name);
    foreach ($instances as $field_name => $instance) {
      $field = field_info_field($field_name);
      if ($field['type'] == 'image') {
        $options[$instance['id']] = $instance['label'] . ' (commerce_product)';
      }
    }

    $fields = field_read_fields(array(
        'entity_type' => 'node',
        'type' => 'commerce_product_reference'
      ));
    $fields = array_keys($fields);
    $instances = field_info_instances('node');
    foreach ($instances as $bundle => $fields) {
      foreach ($fields as $field_name => $field) {
//        dpm($field_name,'$field');

        if (in_array($field_name, $fields)) {
//          dpm($field,'$iffield');
        }
      }
    }

//    dpm($fields ,'$fields');
    $typess = field_info_field_types('commerce_product_reference');
    $settings = field_info_instance_settings('commerce_product_reference');

//  dpm($instances);
//    dpm($typess,'$typess');
//    dpm($settings,'$settings');


    $form['images']['commerce_payqr_image_' . $name] = array(
      '#type' => 'select',
      '#title' => $type['name'],
      '#options' => $options,
      '#default_value' => variable_get('commerce_payqr_image_' . $name, ''),
    );
  }


  return system_settings_form($form);
}

function commerce_payqr_payment_transaction_revert_form($form, &$form_state, $order, $transaction) {
  $form['order'] = array(
    '#type' => 'value',
    '#value' => $order,
  );
  $form['transaction'] = array(
    '#type' => 'value',
    '#value' => $transaction,
  );
  $form['amount'] = array(
    '#type' => 'textfield',
    '#title' => t('Revert amount'),
    '#default_value' => commerce_currency_amount_to_decimal($transaction->amount, $transaction->currency_code),
    '#size' => 60,
    '#maxlength' => 128,
    '#required' => TRUE,
  );

  $form['actions'] = array('#type' => 'actions');
  $form['actions']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Revert'),
  );
  return $form;
}

function commerce_payqr_payment_transaction_revert_form_validate($form, &$form_state) {
  $transaction = $form_state['values']['transaction'];
  $amount = commerce_currency_decimal_to_amount($form_state['values']['amount'], $transaction->currency_code);
  if ($amount > $transaction->amount) {
    form_set_error('amount', t('Revert amount must be less or equal current transaction amount'));
  }
}

function commerce_payqr_payment_transaction_revert_form_submit($form, &$form_state) {
  $order = $form_state['values']['order'];
  $transaction = $form_state['values']['transaction'];
  $amount = commerce_currency_decimal_to_amount($form_state['values']['amount'], $transaction->currency_code);
  payqr_config::$enabledLog = FALSE;
  payqr_config::$merchantID = variable_get('commerce_payqr_merchant_id', '');
  payqr_config::$secretKeyIn = variable_get('commerce_payqr_secret_key_in', '');
  payqr_config::$secretKeyOut = variable_get('commerce_payqr_secret_key_out', '');
  $Payqr_invoice = new payqr_invoice_action();
  $r = $Payqr_invoice->invoice_revert($transaction->remote_id, $form_state['values']['amount']);

//  $transaction = commerce_payment_transaction_load(18);
  $transaction->log = '1111';
  $transaction->revision = TRUE;
  commerce_payment_transaction_save($transaction);

  dpm($r);
  dpm($amount);
  dpm($order);
  dpm($transaction);
  dpm($form_state);
}