<?php
/**
 * Created by PhpStorm.
 * User: niko
 * Date: 31.01.15
 * Time: 16:28
 */

/**
 * нужно вернуть в PayQR список способов доставки для покупателя
 *
 * @param payqr_receiver $Payqr
 */
function _commerce_payqr_invoice_deliverycases_updating(payqr_receiver $Payqr) {
  watchdog('debug', '<pre>!data</pre>', array('!data' => print_r($Payqr, 1)));
  $delivery_cases = _payqr_calculate_delivery($Payqr);
  $prefix = variable_get('commerce_payqr_pickpoints_prefix', 'payqr_pp') . '_';
  foreach ($delivery_cases['delivery_cases'] as $key => $value) {
    if (strpos($value['article'], $prefix) === 0) {
      unset($delivery_cases['delivery_cases'][$key]);
    }
  }

  drupal_alter('payqr_invoice_deliverycases_updating', $delivery_cases['order'], $delivery_cases['delivery_cases']);

  $Payqr->objectOrder->setDeliveryCases($delivery_cases['delivery_cases']);

}

/**
 * нужно вернуть в PayQR список пунктов самовывоза для покупателя
 *
 * @param payqr_receiver $Payqr
 */
function _commerce_payqr_invoice_pickpoints_updating(payqr_receiver $Payqr) {
  watchdog('debug', '<pre>!data</pre>', array('!data' => print_r($Payqr, 1)));
  $pick_points_cases = _payqr_calculate_delivery($Payqr);
  $prefix = variable_get('commerce_payqr_pickpoints_prefix', 'payqr_pp') . '_';
  foreach ($pick_points_cases['delivery_cases'] as $key => $value) {
    if (strpos($value['article'], $prefix) !== 0) {
      unset($pick_points_cases['delivery_cases'][$key]);
    }
  }

  drupal_alter('payqr_invoice_pickpoints_updating', $pick_points_cases['order'], $pick_points_cases['delivery_cases']);

  $Payqr->objectOrder->setPickPointsCases($pick_points_cases['delivery_cases']);
}

/**
 * нужно создать заказ в своей учетной системе, если заказ еще не был создан, и вернуть в PayQR полученный номер заказа (orderId), если его еще не было
 *
 * @param payqr_receiver $Payqr
 */
function _commerce_payqr_invoice_order_creating(payqr_receiver $Payqr) {
  watchdog('debug', '<pre>!data</pre>', array('!data' => print_r($Payqr, 1)));
  global $user;
// @todo create anon\auth logic set order owner
  $cartObject = $Payqr->objectOrder->getCart();
  if ($cartObject) {
    // Create the new order in checkout; you might also check first to
// see if your user already has an order to use instead of a new one.
    $order = commerce_order_new($user->uid, 'checkout_checkout');
    // Save the order to get its ID.
    commerce_order_save($order);
    // Link anonymous user session to the cart
    if (!$user->uid) {
//      $customerObject = $Payqr->objectOrder->getCustomer();
//      if ($customerObject) {
//        $order->$customerObject
//      }
      commerce_cart_order_session_save($order->order_id);
    }

    foreach ($cartObject as $payqr_product) {
      // Load whatever product represents the item the customer will be
// paying for and create a line item for it.0
      $product = commerce_product_load_by_sku($payqr_product->article);
      $line_item = commerce_product_line_item_new($product, $payqr_product->quantity, $order->order_id);
    // Save the line item to get its ID.
      commerce_line_item_save($line_item);
      // Add the line item to the order using fago's rockin' wrapper.
      $order_wrapper = entity_metadata_wrapper('commerce_order', $order);
      $order_wrapper->commerce_line_items[] = $line_item;
    }

//    $profile_types = commerce_customer_profile_types();

    $profile = commerce_customer_profile_new('billing', $user->uid);

//    // Address field
//    $profile->commerce_customer_address['und'][0]['country'] = "BE";
//    $profile->commerce_customer_address['und'][0]['administrative_area'] = NULL;
//    $profile->commerce_customer_address['und'][0]['sub_administrative_area'] = NULL;
//    $profile->commerce_customer_address['und'][0]['locality'] = "Antwerpen";
//    $profile->commerce_customer_address['und'][0]['dependent_locality'] = NULL;
//    $profile->commerce_customer_address['und'][0]['postal_code'] = "2000";
//    $profile->commerce_customer_address['und'][0]['thoroughfare'] = "Markt 1";
//    $profile->commerce_customer_address['und'][0]['premise'] = "";
//    $profile->commerce_customer_address['und'][0]['sub_premise'] = "";
//    $profile->commerce_customer_address['und'][0]['organisation_name'] = "";
//    $profile->commerce_customer_address['und'][0]['name_line'] = "Jimmy Henderickx";
//    $profile->commerce_customer_address['und'][0]['first_name'] = "Jimmy";
//    $profile->commerce_customer_address['und'][0]['last_name'] = "Henderickx";
//    $profile->commerce_customer_address['und'][0]['data'] = NULL;

    commerce_customer_profile_save($profile);

    //create the right array for the save controller
    $profile_object = array (
      'und' => array (
        array (
          'profile_id' => $profile->profile_id,
        ),
      ),
    );

    $order->commerce_customer_billing = $profile_object;

    if (module_exists('commerce_shipping')) {
      $profile = commerce_customer_profile_new('shipping', $user->uid);
      commerce_customer_profile_save($profile);
      //create the right array for the save controller
      $profile_object = array (
        'und' => array (
          array (
            'profile_id' => $profile->profile_id,
          ),
        ),
      );

      $order->commerce_customer_shipping = $profile_object;

      // Add shipping to order if any selected.
      $shipping_service = $Payqr->objectOrder->getDeliveryCasesSelected();
      if ($shipping_service) {
        $service_name = $shipping_service->article;
        // Make the chosen service available to the order.
        commerce_shipping_service_rate_order($service_name, $order);
        // Delete any existing shipping line items from the order.
        commerce_shipping_delete_shipping_line_items($order, TRUE);

        // Extract the unit price from the calculated rate.
        $rate_line_item = $order->shipping_rates[$service_name];
        $rate_line_item_wrapper = entity_metadata_wrapper('commerce_line_item', $rate_line_item);
        $unit_price = $rate_line_item_wrapper->commerce_unit_price->value();

        // Create a new shipping line item with the calculated rate from the form.
        $line_item = commerce_shipping_line_item_new($service_name, $unit_price, $order->order_id, $rate_line_item->data, $rate_line_item->type);

        // Save and add the line item to the order.
        commerce_shipping_add_shipping_line_item($line_item, $order, TRUE);
      }
    }



   // Save the order again to update its line item reference field.
    commerce_order_save($order);
    $wrapper = entity_metadata_wrapper('commerce_order', $order);
    $transaction = commerce_payment_transaction_new('commerce_payqr', $order->order_id);
    $transaction->instance_id = 'commerce_payqr|commerce_payment_commerce_payqr';
    $transaction->amount =  commerce_currency_decimal_to_amount($Payqr->objectOrder->getAmount(), $wrapper->commerce_order_total->currency_code->value());
    $transaction->currency_code = $wrapper->commerce_order_total->currency_code->value();
    $transaction->status = COMMERCE_PAYMENT_STATUS_PENDING;
    $transaction->remote_id = $Payqr->objectOrder->getInvId();
    $transaction->message = $Payqr->getType();
    $transaction->remote_status = $Payqr->getType();
    $transaction->payload = $Payqr;
    $transaction->revision = TRUE;
    commerce_payment_transaction_save($transaction);
    $Payqr->objectOrder->setOrderId($order->order_id);
    $Payqr->objectOrder->setOrderGroup($transaction->transaction_id);
  }
}

/**
 * нужно зафиксировать успешную оплату конкретного заказа
 *
 * @param payqr_receiver $Payqr
 */
function _commerce_payqr_invoice_paid(payqr_receiver $Payqr) {
  watchdog('debug', '<pre>!data</pre>', array('!data' => print_r($Payqr, 1)));
  $transaction_id = $Payqr->objectOrder->getOrderGroup();
  $transaction = commerce_payment_transaction_load($transaction_id);
  if ($transaction) {
    $transaction->status = COMMERCE_PAYMENT_STATUS_SUCCESS;
    $transaction->remote_id = $Payqr->objectOrder->getInvId();
    $transaction->message = $Payqr->getType();
    $transaction->remote_status = $Payqr->getType();
    $transaction->payload = $Payqr;
    $transaction->revision = TRUE;
    $transaction->log = $Payqr->getType();

    commerce_payment_transaction_save($transaction);
    $order = commerce_order_load($transaction->order_id);
    if ($order) {
      commerce_order_status_update($order,'checkout_complete');
      commerce_checkout_complete($order);
    }
  }
}

/**
 * ошибка совершения покупки, операция дальше продолжаться не будет
 *
 * @param payqr_receiver $Payqr
 */
function _commerce_payqr_invoice_failed(payqr_receiver $Payqr) {
  watchdog('debug', '<pre>!data</pre>', array('!data' => print_r($Payqr, 1)));
  $transaction_id = $Payqr->objectOrder->getOrderGroup();
  $transaction = commerce_payment_transaction_load($transaction_id);
  if ($transaction) {
    $transaction->status = COMMERCE_PAYMENT_STATUS_FAILURE;
    $transaction->remote_id = $Payqr->objectOrder->getInvId();
    $transaction->message = $Payqr->getType();
    $transaction->remote_status = $Payqr->getType();
    $transaction->payload = $Payqr;
    $transaction->revision = TRUE;
    $transaction->log = $Payqr->getType();

    commerce_payment_transaction_save($transaction);
    $order = commerce_order_load($transaction->order_id);
    if ($order) {
      commerce_order_status_update($order, 'canceled');
    }
  }
}

/**
 * PayQR зафиксировал отказ интернет-сайта от получения оплаты по конкретному заказу
 *
 * @param payqr_receiver $Payqr
 */
function _commerce_payqr_invoice_cancelled(payqr_receiver $Payqr) {
  watchdog('debug', '<pre>!data</pre>', array('!data' => print_r($Payqr, 1)));
  $transaction_id = $Payqr->objectOrder->getOrderGroup();
  $transaction = commerce_payment_transaction_load($transaction_id);
  if ($transaction) {
    $transaction->status = COMMERCE_PAYQR_STATUS_CANCELLED;
    $transaction->remote_id = $Payqr->objectOrder->getInvId();
    $transaction->message = $Payqr->getType();
    $transaction->remote_status = $Payqr->getType();
    $transaction->payload = $Payqr;
    $transaction->revision = TRUE;
    $transaction->log = $Payqr->getType();

    commerce_payment_transaction_save($transaction);
    $order = commerce_order_load($transaction->order_id);
    if ($order) {
      commerce_order_status_update($order, 'canceled');
    }
  }
}

/**
 * PayQR зафиксировал полную отмену конкретного счета (заказа) и возврат всей суммы денежных средств по нему
 *
 * @param payqr_receiver $Payqr
 */
function _commerce_payqr_invoice_reverted(payqr_receiver $Payqr) {
  watchdog('debug', '<pre>!data</pre>', array('!data' => print_r($Payqr, 1)));
  $transaction_id = $Payqr->objectOrder->getOrderGroup();
  $transaction = commerce_payment_transaction_load($transaction_id);
  if ($transaction) {
    $transaction->status = COMMERCE_PAYQR_STATUS_REVERTED;
    $transaction->remote_id = $Payqr->objectOrder->getInvId();
    $transaction->message = $Payqr->getType();
    $transaction->remote_status = $Payqr->getType();
    $transaction->payload = $Payqr;
    $transaction->revision = TRUE;
    $transaction->log = $Payqr->getType();

    commerce_payment_transaction_save($transaction);
    $order = commerce_order_load($transaction->order_id);
    if ($order) {
      commerce_order_status_update($order, 'canceled');
    }
  }
}

/**
 * PayQR отказал интернет-сайту в отмене счета и возврате денежных средств покупателю
 *
 * @param payqr_receiver $Payqr
 */
function _commerce_payqr_revert_failed(payqr_receiver $Payqr) {
  watchdog('debug', '<pre>!data</pre>', array('!data' => print_r($Payqr, 1)));
  $transaction_id = $Payqr->objectOrder->getOrderGroup();
  $transaction = commerce_payment_transaction_load($transaction_id);
  if ($transaction) {
    $transaction->status = COMMERCE_PAYQR_STATUS_REVERT_FAILED;
    $transaction->remote_id = $Payqr->objectOrder->getInvId();
    $transaction->message = $Payqr->getType();
    $transaction->remote_status = $Payqr->getType();
    $transaction->payload = $Payqr;
    $transaction->revision = TRUE;
    $transaction->log = $Payqr->getType();

    commerce_payment_transaction_save($transaction);
    $order = commerce_order_load($transaction->order_id);
    if ($order) {
      commerce_order_status_update($order, 'canceled');
    }
  }
}

/**
 * PayQR зафиксировал отмену счета интернет-сайтом и вернул денежные средства покупателю
 *
 * @param payqr_receiver $Payqr
 */
function _commerce_payqr_revert_succeeded(payqr_receiver $Payqr) {
  watchdog('debug', '<pre>!data</pre>', array('!data' => print_r($Payqr, 1)));
  $transaction_id = $Payqr->objectOrder->getOrderGroup();
  $transaction = commerce_payment_transaction_load($transaction_id);
  if ($transaction) {
    $transaction->status = COMMERCE_PAYQR_STATUS_REVERT_SUCCEEDED;
    $transaction->remote_id = $Payqr->objectOrder->getInvId();
    $payqr_amount = $Payqr->objectOrder->getAmount(); // @todo check this
    $transaction->amount = $transaction->amount - commerce_currency_decimal_to_amount($payqr_amount, $transaction->currency_code);
    $transaction->message = $Payqr->getType();
    $transaction->remote_status = $Payqr->getType();
    $transaction->payload = $Payqr;
    $transaction->revision = TRUE;
    $transaction->log = $Payqr->getType();

    commerce_payment_transaction_save($transaction);
    $order = commerce_order_load($transaction->order_id);
    if ($order) {
      commerce_order_status_update($order, 'canceled');
    }
  }
}

/**
 * Shipping services applied to order helper.
 *
 * @param payqr_receiver $Payqr
 * @return array
 */
function _payqr_calculate_delivery(payqr_receiver $Payqr){
  global $user;

  // create temporarry commerce_order based on data from PayQR for shipping methods calculating
  $order = commerce_order_new($user->uid, 'checkout_checkout');

  $cartObject = $Payqr->objectOrder->getCart();
  foreach ($cartObject as $payqr_product) {
    // Load whatever product represents the item the customer will be
// paying for and create a line item for it.0
    $product = commerce_product_load_by_sku($payqr_product->article);
    $line_item = commerce_product_line_item_new($product, $payqr_product->quantity, $order->order_id);
    // Save the line item to get its ID.
    commerce_line_item_save($line_item);
    // Add the line item to the order using fago's rockin' wrapper.
    $order_wrapper = entity_metadata_wrapper('commerce_order', $order);
    $order_wrapper->commerce_line_items[] = $line_item;
  }
  commerce_shipping_collect_rates($order);
  $options = commerce_shipping_service_rate_options($order);
  watchdog('debug', '<pre>!data</pre>', array('!data' => print_r($order, 1)));
  watchdog('debug', '<pre>!data</pre>', array('!data' => print_r($options, 1)));
  $delivery_cases = array();
  $i = 0;
  foreach ($order->shipping_rates as $name => $line_item) {
    $line_item_wrapper = entity_metadata_wrapper('commerce_line_item', $line_item);
    $delivery_price = commerce_currency_amount_to_decimal($line_item_wrapper->commerce_unit_price->amount->value(), $line_item_wrapper->commerce_unit_price->currency_code->value());
    $delivery_description = $line_item->data['shipping_service']['description'];
    $delivery_cases[] = array(
      'article' => $name,
      'number' => ++$i,
      'name' => commerce_shipping_line_item_title($line_item),
      'description' => $delivery_description,
      'amountFrom' => $delivery_price,
      'amountTo' => $delivery_price,
    );
  }

  watchdog('$delivery_cases', '<pre>!data</pre>', array('!data' => print_r($delivery_cases, 1)));
  return array(
    'delivery_cases' => $delivery_cases,
    'order' =>$order,
  );
}