<?php
/**
 * Created by PhpStorm.
 * User: oleg
 * Date: 08.02.15
 * Time: 14:11
 */

/**
 *  Implements hook_views_data().
 */
function commerce_payqr_views_data() {
  $data['commerce_payment_transaction_revision']['table']['entity type'] = 'commerce_payment_transaction';
  $data['commerce_payment_transaction_revision']['table']['group'] = t('Commerce Payment Transaction revision');
  $data['commerce_payment_transaction_revision']['table']['base'] = array(
    'field' => 'revision_id',
    'title' => t('Commerce Payment Transaction revision'),
    'access query tag' => 'commerce_payment_transaction_access',
    'defaults' => array(
      'field' => 'log',
    ),
  );

  $data['commerce_payment_transaction_revision']['table']['join'] = array(
    'commerce_payment_transaction' => array(
      'left_field' => 'transaction_id',
      'field' => 'transaction_id',
    ),
  );

  $data['commerce_payment_transaction_revision']['table']['default_relationship'] = array(
    'commerce_payment_transaction' => array(
      'table' => 'commerce_payment_transaction',
      'field' => 'revision_id',
    ),
  );

  // Expose the transaction ID.
  $data['commerce_payment_transaction_revision']['transaction_id'] = array(
    'title' => t('Transaction ID'),
    'help' => t('The unique internal identifier of the transaction revision belong to.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );


  // Expose the revision ID.
  $data['commerce_payment_transaction_revision']['revision_id'] = array(
    'title' => t('Revision ID'),
    'help' => t('The revision ID of the transaction revision.'),
    'field' => array(
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'commerce_payment_transaction',
      'base field' => 'revision_id',
      'title' => t('Transaction'),
      'label' => t('Latest transaction revision'),
    ),
  );

  // Expose the transaction revision user ID.
  $data['commerce_payment_transaction_revision']['revision_uid'] = array(
    'title' => t('User'),
    'help' => t('Relate a transaction revision to the user who created the revision.'),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'users',
      'base field' => 'uid',
      'field' => 'revision_uid',
      'field_name' => 'revision_uid',
      'label' => t('Revision user'),
    ),
  );

  // Expose the transaction revision status.
  $data['commerce_payment_transaction_revision']['status'] = array(
    'title' => t('Status'),
    'help' => t('The status of this transaction revision.'),
    'field' => array(
      'handler' => 'commerce_payment_handler_field_status',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'commerce_payment_handler_filter_payment_transaction_status',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Expose the order revision log.
  $data['commerce_payment_transaction_revision']['log'] = array(
    'title' => t('Log message'),
    'help' => t('The log message entered when the revision was created.'),
    'field' => array(
      'handler' => 'views_handler_field_xss',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
  );

  // Expose the order revision remote id.
  $data['commerce_payment_transaction_revision']['remote_id'] = array(
    'title' => t('Remote ID'),
    'help' => t('The Remote ID entered when the revision was created.'),
    'field' => array(
      'handler' => 'views_handler_field_xss',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
  );

  // Expose the revision's remote status.
  $data['commerce_payment_transaction_revision']['remote_status'] = array(
    'title' => t('Remote status'),
    'help' => t('The status of this transaction revision at the payment provider.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Expose the revision amount.
  $data['commerce_payment_transaction_revision']['amount'] = array(
    'title' => t('Amount'),
    'help' => t('The amount of the transaction.'),
    'field' => array(
      'handler' => 'commerce_payment_handler_field_amount',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );

  // Expose the revision currency.
  $data['commerce_payment_transaction_revision']['currency_code'] = array(
    'title' => t('Currency'),
    'help' => t('The currency of the transaction.'),
    'field' => array(
      'handler' => 'commerce_payment_handler_field_currency_code',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'commerce_payment_handler_filter_currency_code',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Expose the revision message.
  $data['commerce_payment_transaction_revision']['message'] = array(
    'title' => t('Message'),
    'help' => t('The message associated with the transaction revision.'),
    'field' => array(
      'handler' => 'commerce_payment_handler_field_message',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );


  // Expose the revision timestamp.
  $data['commerce_payment_transaction_revision']['revision_timestamp'] = array(
    'title' => t('Revision date'),
    'help' => t('The date the product revision was created.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
  );




  return $data;
}